Index: LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90	(revision 2298)
@@ -6,18 +6,15 @@
 CONTAINS
 !
-!****************************************************************************************
+!******************************************************************************
 !
   SUBROUTINE surf_ocean(rlon, rlat, swnet, lwnet, alb1, &
-       rugos, windsp, rmu0, fder, tsurf_in, &
+       windsp, rmu0, fder, tsurf_in, &
        itime, dtime, jour, knon, knindex, &
-       p1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
+       p1lay, z1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
-       ps, u1, v1, rugoro, pctsrf, &
+       ps, u1, v1, gustiness, rugoro, pctsrf, &
        snow, qsurf, agesno, &
-!albedo SB >>>
-!      z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
-       z0_new, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, & 
-!albedo SB <<<
+       z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, & 
        tsurf_new, dflux_s, dflux_l, lmt_bils, &
        flux_u1, flux_v1)
@@ -41,5 +38,5 @@
 
 ! Input variables
-!****************************************************************************************
+!******************************************************************************
     INTEGER, INTENT(IN)                      :: itime, jour, knon
     INTEGER, DIMENSION(klon), INTENT(IN)     :: knindex
@@ -49,10 +46,9 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: lwnet  ! net longwave radiation at surface  
     REAL, DIMENSION(klon), INTENT(IN)        :: alb1   ! albedo in visible SW interval
-    REAL, DIMENSION(klon), INTENT(IN)        :: rugos
     REAL, DIMENSION(klon), INTENT(IN)        :: windsp
     REAL, DIMENSION(klon), INTENT(IN)        :: rmu0  
     REAL, DIMENSION(klon), INTENT(IN)        :: fder
     REAL, DIMENSION(klon), INTENT(IN)        :: tsurf_in
-    REAL, DIMENSION(klon), INTENT(IN)        :: p1lay
+    REAL, DIMENSION(klon), INTENT(IN)        :: p1lay,z1lay ! pression (Pa) et altitude (m) du premier niveau
     REAL, DIMENSION(klon), INTENT(IN)        :: cdragh
     REAL, DIMENSION(klon), INTENT(IN)        :: cdragm
@@ -62,10 +58,10 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: AcoefU, AcoefV, BcoefU, BcoefV
     REAL, DIMENSION(klon), INTENT(IN)        :: ps
-    REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1
+    REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1, gustiness
     REAL, DIMENSION(klon), INTENT(IN)        :: rugoro
     REAL, DIMENSION(klon,nbsrf), INTENT(IN)  :: pctsrf
 
 ! In/Output variables
-!****************************************************************************************
+!******************************************************************************
     REAL, DIMENSION(klon), INTENT(INOUT)     :: snow
     REAL, DIMENSION(klon), INTENT(INOUT)     :: qsurf
@@ -73,6 +69,6 @@
 
 ! Output variables
-!****************************************************************************************
-    REAL, DIMENSION(klon), INTENT(OUT)       :: z0_new
+!******************************************************************************
+    REAL, DIMENSION(klon), INTENT(OUT)       :: z0m, z0h
 !albedo SB >>>
 !    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new  ! new albedo in visible SW interval
@@ -88,5 +84,5 @@
 
 ! Local variables
-!****************************************************************************************
+!******************************************************************************
     INTEGER               :: i, k
     REAL                  :: tmp
@@ -94,19 +90,37 @@
     REAL, DIMENSION(klon) :: alb_eau
     REAL, DIMENSION(klon) :: radsol
+    REAL, DIMENSION(klon) :: cdragq ! Cdrag pour l'evaporation
 
 ! End definition
-!****************************************************************************************
-
-
-!****************************************************************************************
+!******************************************************************************
+
+
+!******************************************************************************
 ! Calculate total net radiance at surface
 !
-!****************************************************************************************
+!******************************************************************************
     radsol(:) = 0.0
     radsol(1:knon) = swnet(1:knon) + lwnet(1:knon)
 
-!****************************************************************************************
+!******************************************************************************
+! Cdragq computed from cdrag
+! The difference comes only from a factor (f_z0qh_oce) on z0, so that
+! it can be computed inside surf_ocean
+! More complicated appraches may require the propagation through
+! pbl_surface of an independant cdragq variable.
+!******************************************************************************
+
+    IF ( f_z0qh_oce .ne. 1.) THEN
+! Si on suit les formulations par exemple de Tessel, on 
+! a z0h=0.4*nu/u*, z0q=0.62*nu/u*, d'ou f_z0qh_oce=0.62/0.4=1.55
+       cdragq(:)=cdragh(:)*                                      &
+       log(z1lay(:)/z0h(:))/log(z1lay(:)/(f_z0qh_oce*z0h(:)))
+    ELSE
+       cdragq(:)=cdragh(:)
+    ENDIF
+
+!******************************************************************************
 ! Switch according to type of ocean (couple, slab or forced)
-!****************************************************************************************
+!******************************************************************************
     SELECT CASE(type_ocean)
     CASE('couple')
@@ -115,8 +129,8 @@
             windsp, fder, & 
             itime, dtime, knon, knindex, &
-            p1lay, cdragh, cdragm, precip_rain, precip_snow,temp_air,spechum,& 
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow,temp_air,spechum,& 
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-            ps, u1, v1, &
+            ps, u1, v1, gustiness, &
             radsol, snow, agesno, &
             qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
@@ -126,8 +140,8 @@
        CALL ocean_slab_noice( &
             itime, dtime, jour, knon, knindex, &
-            p1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum,&
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow, temp_air, spechum,&
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-            ps, u1, v1, tsurf_in, &
+            ps, u1, v1, gustiness, tsurf_in, &
             radsol, snow, &
             qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
@@ -137,9 +151,9 @@
        CALL ocean_forced_noice( &
             itime, dtime, jour, knon, knindex, &
-            p1lay, cdragh, cdragm, precip_rain, precip_snow, &
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow, &
             temp_air, spechum, &
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-            ps, u1, v1, &
+            ps, u1, v1, gustiness, &
             radsol, snow, agesno, &
             qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
@@ -147,7 +161,7 @@
     END SELECT
 
-!****************************************************************************************
+!******************************************************************************
 ! fcodron: compute lmt_bils  forced case (same as wfbils_oce / 1.-contfracatm)
-!****************************************************************************************
+!******************************************************************************
     IF (type_ocean.NE.'slab') THEN
         lmt_bils(:)=0.
@@ -158,11 +172,8 @@
     END IF
 
-!****************************************************************************************
+!******************************************************************************
 ! Calculate albedo
-!
-!****************************************************************************************
+!******************************************************************************
 !albedo SB >>>
-
-
   if(iflag_albedo==1)then
     call ocean_albedo(knon,rmu0,knindex,windsp,SFRWL,alb_dir_new,alb_dif_new)
@@ -184,20 +195,31 @@
 !albedo SB <<<
 
-!****************************************************************************************
+!******************************************************************************
 ! Calculate the rugosity
-!
-!****************************************************************************************
+!******************************************************************************
+IF (iflag_z0_oce==0) THEN
     DO i = 1, knon
-       tmp = MAX(cepdu2,u1(i)**2+v1(i)**2)
-       z0_new(i) = 0.018*cdragm(i) * (u1(i)**2+v1(i)**2)/RG  &
+       tmp = MAX(cepdu2,gustiness(i)+u1(i)**2+v1(i)**2)
+       z0m(i) = 0.018*cdragm(i) * (gustiness(i)+u1(i)**2+v1(i)**2)/RG  &
             +  0.11*14e-6 / SQRT(cdragm(i) * tmp)
-       z0_new(i) = MAX(1.5e-05,z0_new(i))
+       z0m(i) = MAX(1.5e-05,z0m(i))
     ENDDO   
-!
-!****************************************************************************************
-!    
+    z0h(1:knon)=z0m(1:knon) ! En attendant mieux
+
+ELSE IF (iflag_z0_oce==1) THEN
+    DO i = 1, knon
+       tmp = MAX(cepdu2,gustiness(i)+u1(i)**2+v1(i)**2)
+       z0m(i) = 0.018*cdragm(i) * (gustiness(i)+u1(i)**2+v1(i)**2)/RG  &
+            + 0.11*14e-6 / SQRT(cdragm(i) * tmp)
+       z0m(i) = MAX(1.5e-05,z0m(i))
+       z0h(i)=0.4*14e-6 / SQRT(cdragm(i) * tmp)
+    ENDDO
+ELSE
+       STOP'version non prevue'
+ENDIF
+!
+!******************************************************************************
   END SUBROUTINE surf_ocean
-!
-!****************************************************************************************
+!******************************************************************************
 !
 END MODULE surf_ocean_mod
Index: LMDZ5/branches/testing/libf/phylmd/surf_seaice_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_seaice_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/surf_seaice_mod.F90	(revision 2298)
@@ -17,10 +17,7 @@
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
-       ps, u1, v1, rugoro, pctsrf, &
+       ps, u1, v1, gustiness, pctsrf, &
        snow, qsurf, qsol, agesno, tsoil, &
-!albedo SB >>>
-!      z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
-       z0_new, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &  
-!albedo SB <<<
+       z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &  
        tsurf_new, dflux_s, dflux_l, &
        flux_u1, flux_v1)
@@ -60,6 +57,5 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: AcoefU, AcoefV, BcoefU, BcoefV
     REAL, DIMENSION(klon), INTENT(IN)        :: ps
-    REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1
-    REAL, DIMENSION(klon), INTENT(IN)        :: rugoro
+    REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1, gustiness
     REAL, DIMENSION(klon,nbsrf), INTENT(IN)  :: pctsrf
 
@@ -72,5 +68,5 @@
 ! Output arguments
 !****************************************************************************************
-    REAL, DIMENSION(klon), INTENT(OUT)       :: z0_new
+    REAL, DIMENSION(klon), INTENT(OUT)       :: z0m, z0h
 !albedo SB >>>
 !    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new  ! new albedo in visible SW interval
@@ -117,5 +113,5 @@
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-            ps, u1, v1, pctsrf, &
+            ps, u1, v1, gustiness, pctsrf, &
             radsol, snow, qsurf, &
             alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
@@ -128,5 +124,5 @@
           AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-          ps, u1, v1, &
+          ps, u1, v1, gustiness, &
           radsol, snow, qsurf, qsol, agesno, &
           alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
@@ -139,5 +135,5 @@
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
-            ps, u1, v1, &
+            ps, u1, v1, gustiness, &
             radsol, snow, qsol, agesno, tsoil, &
             qsurf, alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
@@ -150,7 +146,7 @@
 !
 !****************************************************************************************
-    z0_new = 0.002
-    z0_new = SQRT(z0_new**2+rugoro**2)
 
+    z0m=z0m_seaice
+    z0h = z0h_seaice
 
 !albedo SB >>>
Index: LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/thermcell_plume.F90	(revision 2298)
@@ -6,6 +6,6 @@
      &           lalim,f0,detr_star,entr_star,f_star,csc,ztva,  &
      &           ztla,zqla,zqta,zha,zw2,w_est,ztva_est,zqsatth,lmix,lmix_bis,linter &
-     &           ,lev_out,lunout1,igout)
-!    &           ,lev_out,lunout1,igout,zbuoy,zbuoyjam)
+    &           ,lev_out,lunout1,igout)
+!     &           ,lev_out,lunout1,igout,zbuoy,zbuoyjam)
 !--------------------------------------------------------------------------
 !thermcell_plume: calcule les valeurs de qt, thetal et w dans l ascendance
@@ -87,5 +87,5 @@
       real ztv_est1,ztv_est2
       real zcor,zdelta,zcvm5,qlbef
-      real zbetalpha
+      real zbetalpha, coefzlmel
       real eps
       REAL REPS,RLvCp,DDT0
@@ -396,4 +396,5 @@
         else  !   if (iflag_thermals_ed.lt.8) then
            lt=l+1
+           zlt=zlev(ig,lt)
            zdz2=zlev(ig,lt)-zlev(ig,l)
 
@@ -405,7 +406,8 @@
            zdz3=zlev(ig,lt+1)-zlt
            zltdwn=zlev(ig,lt)-zdz3/2
-
-           zbuoyjam(ig,l)=1.*RG*(((lmel+zdz3-zdz2)/zdz3)*(ztva_est(ig,l)- & 
-    &          ztv(ig,lt))/ztv(ig,lt)+((zdz2-lmel)/zdz3)*(ztva_est(ig,l)- &
+           zlmelup=zlmel+(zdz/2)
+           coefzlmel=Min(1.,(zlmelup-zltdwn)/zdz)
+           zbuoyjam(ig,l)=1.*RG*(coefzlmel*(ztva_est(ig,l)- & 
+    &          ztv(ig,lt))/ztv(ig,lt)+(1.-coefzlmel)*(ztva_est(ig,l)- &
     &          ztv(ig,lt-1))/ztv(ig,lt-1))+0.*zbuoy(ig,l)
         endif !   if (iflag_thermals_ed.lt.8) then
@@ -422,4 +424,5 @@
               zdw2=afact*zbuoy(ig,l)/fact_epsilon
               zdw2bis=afact*zbuoy(ig,l-1)/fact_epsilon
+!              zdw2bis=0.5*(zdw2+zdw2bis)
               lm=Max(1,l-2)
 !              zdw2=(afact/fact_epsilon)*((zdz/zdzbis)*zbuoy(ig,l) &
@@ -442,5 +445,5 @@
 !    &                     (exp(-zw2factbis)*(w_est(ig,l-1)-zdw2bis)+zdw2))
 
-	    w_est(ig,l+1)=Max(0.0001,exp(-zw2fact)*(w_est(ig,l)-zdw2bis)+zdw2)
+	    w_est(ig,l+1)=Max(0.0001,exp(-zw2fact)*(w_est(ig,l)-zdw2)+zdw2)
 
 ! Nouvelle version Arnaud
@@ -556,5 +559,5 @@
     &       mix0 * 0.1 / (zalpha+0.001)               &
     &     + zbetalpha*MAX(entr_min,                   &
-    &     afact*zbuoyjam(ig,l)/zw2m - fact_epsilon ))
+    &     afact*zbuoyjam(ig,l)/zw2m - fact_epsilon))
 
 
@@ -645,7 +648,11 @@
 !    &                     (zw2(ig,l)-zdw2)+zdw2)+(zdzbis-zdz)/zdzbis* &
 !    &                     (exp(-zw2factbis)*(zw2(ig,l-1)-zdw2bis)+zdw2))
+            if (iflag_thermals_ed==8) then
+	    zw2(ig,l+1)=Max(0.0001,exp(-zw2fact)*(zw2(ig,l)-zdw2)+zdw2)
+            else
 	    zw2(ig,l+1)=Max(0.0001,exp(-zw2fact)*(zw2(ig,l)-zdw2bis)+zdw2)
+            endif
 !            zw2(ig,l+1)=Max(0.0001,(zdz/(zdz+zdzbis))*(exp(-zw2fact)* &
-!    &                     (zw2(ig,l)-zdw2bis)+zdw2)+(zdzbis/(zdz+zdzbis))* &
+!    &                     (zw2(ig,l)-zdw2)+zdw2bis)+(zdzbis/(zdz+zdzbis))* &
 !    &                     (exp(-zw2factbis)*(zw2(ig,l-1)-zdw2bis)+zdw2bis))
 
Index: LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 2298)
@@ -174,6 +174,7 @@
     id_pcsat=0; id_pcocsat=0; id_pcq=0; id_pcs0=0; id_pcos0=0; id_pcq0=0
     DO it=1,nbtr
-       iiq=niadv(it+2)
-       IF ( tname(iiq) == "RN" ) THEN
+!!       iiq=niadv(it+2)                                                            ! jyg
+       iiq=niadv(it+nqo)                                                            ! jyg
+       IF ( tname(iiq) == "RN" ) THEN                                               
           id_rn=it ! radon
        ELSE IF ( tname(iiq) == "PB") THEN
@@ -293,5 +294,6 @@
 ! ----------------------------------------------
     DO it=1,nbtr
-       iiq=niadv(it+2)
+!!       iiq=niadv(it+2)                                                            ! jyg
+       iiq=niadv(it+nqo)                                                            ! jyg
        ! Test if tracer is zero everywhere. 
        ! Done by master process MPI and master thread OpenMP
Index: LMDZ5/branches/testing/libf/phylmd/undefSTD.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/undefSTD.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/undefSTD.F90	(revision 2298)
@@ -5,7 +5,13 @@
   USE netcdf
   USE dimphy
-  USE phys_state_var_mod ! Variables sauvegardees de la physique
+#ifdef CPP_IOIPSL 
+  USE phys_state_var_mod
+#endif
+
   IMPLICIT NONE
   include "clesphys.h"
+#ifdef CPP_IOIPSL 
+  REAL :: missing_val
+#endif
 
   ! ====================================================================
@@ -51,7 +57,10 @@
   ! REAL tnondef(klon,klevSTD,nout)
 
-  REAL missing_val
+! REAL missing_val
 
-  missing_val = nf90_fill_real
+! missing_val = nf90_fill_real
+#ifndef CPP_XIOS
+      missing_val=missing_val_nf90
+#endif
 
   DO n = 1, nout
Index: LMDZ5/branches/testing/libf/phylmd/write_histrac.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/write_histrac.h	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/write_histrac.h	(revision 2298)
@@ -17,5 +17,6 @@
 !----------------
      DO it=1,nbtr
-        iiq=niadv(it+2)
+!!        iiq=niadv(it+2)                                                           ! jyg
+        iiq=niadv(it+nqo)                                                           ! jyg
 
 ! CONCENTRATIONS
